<?php
/**
 * Coppermine Photo Gallery
 * Coppermine version: 1.5.xx
 *
 * Home Search ver 1.0
 *
 * Plugin Written by Joe Carver - http://gallery.josephcarver.com/natural/ - http://i-imagine.net/artists/
 * 22 August 2010
*/

require_once('plugins/home_search/init.inc.php');

	if (!GALLERY_ADMIN_MODE) {
		cpg_die(ERROR, $lang_errors['perm_denied'], __FILE__, __LINE__);
	}
	
	if (in_array('plugins/iscroll/js/config.js', $JS['includes']) != TRUE) {
		$JS['includes'][] = 'plugins/home_search/js/admin.js';
	}	
	
	if (in_array('js/jquery.spinbutton.js', $JS['includes']) != TRUE) {
	$JS['includes'][] = 'js/jquery.spinbutton.js';
	}
	pageheader(sprintf($home_search_lang['configure_plugin_x'], $home_search_lang['display_name']));
	
    global $lang_plugin_php, $CONFIG, $lang_common, $lang_pluginmgr_php, $lang_admin_php, $icon_array;

	list($timestamp, $form_token) = getFormToken();

	// get sanitized POST parameters
		if ($superCage->post->keyExists('submit')) {
		//Check if the form token is valid
		if(!checkFormToken()){
			cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
		}
	
  // Define the sanitization patterns
  $sanitization_array = array(
      'search_type' => array('type' => 'int', 'min' => '0', 'max' => '2'),
      'search_title' => array('type' => 'checkbox', 'min' => '0', 'max' => '1'),	  
      'search_caption' => array('type' => 'checkbox', 'min' => '0', 'max' => '1'),	
      'search_keywords' => array('type' => 'checkbox', 'min' => '0', 'max' => '1'),	  
      'search_filename' => array('type' => 'checkbox', 'min' => '0', 'max' => '1'),
      'main_page_layout' => array('type' => 'array', 'regex_ok' => '/^[a-z]+$/', 'delimiter' => '/')	
  );
  $config_changes_counter = 0;
  foreach ($sanitization_array as $san_key => $san_value) {
      if (isset($CONFIG[$san_key]) == TRUE) { // only loop if config value is set --- start
          if ($san_value['type'] == 'checkbox') { // type is checkbox --- start
            if ($superCage->post->getInt($san_key) == $san_value['max'] && $CONFIG[$san_key] != $san_value['max']) {
                $CONFIG[$san_key] = $san_value['max'];
                cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                $config_changes_counter++;
            } elseif($superCage->post->getInt($san_key) == $san_value['min'] && $CONFIG[$san_key] != $san_value['min']) {
                $CONFIG[$san_key] = $san_value['min'];
                cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                $config_changes_counter++;
            } elseif($superCage->post->keyExists($san_key) != TRUE && $CONFIG[$san_key] != '0') {
                $CONFIG[$san_key] = 0;
                cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                $config_changes_counter++;
            }
          } // type is checkbox --- end
          if ($san_value['type'] == 'int') { // type is integer --- start
              if ($superCage->post->getInt($san_key) <= $san_value['max'] && $superCage->post->getInt($san_key) >= $san_value['min'] && $superCage->post->getInt($san_key) != $CONFIG[$san_key]) {
                  $CONFIG[$san_key] = $superCage->post->getInt($san_key);
                  cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                  $config_changes_counter++;
              }
          } // type is integer --- end	
	          if ($san_value['type'] == 'array') { // type is array --- start              
          $evaluate_value = $superCage->post->getRaw($san_key);
              //print_r($superCage->post->getRaw($san_key));
              if (is_array($evaluate_value) && isset($san_value['regex_ok']) == TRUE && isset($san_value['delimiter']) == TRUE) {
                  $temp = '';
                  for ($i = 0; $i <= count($evaluate_value); $i++) {
                      if (preg_match($san_value['regex_ok'], $evaluate_value[$i])) {
                          $temp .= $evaluate_value[$i] . $san_value['delimiter'];
                      }
                  }
                  unset($evaluate_value);
                  $evaluate_value = rtrim($temp, $san_value['delimiter']);
                  unset($temp);
              }
              if ($evaluate_value != $CONFIG[$san_key]) {
                  $CONFIG[$san_key] = $evaluate_value;
                  cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                  $config_changes_counter++;
              }
          } // type is array --- end
      } // only loop if config value is set --- end
  }
}	
	
// +++++++++++++++++++++++	
	// vars from db and for form
	$type_search = ($CONFIG['search_type']);
	
			$list_one = '';
		   if ($type_search  == '0') {
	   		$list_one = 'selected="selected"';
	}
			$list_two = '';
		   if ($type_search  == '1') {
	   		$list_two = 'selected="selected"';
	}
			$list_three = '';	
		   if ($type_search  == '2') {
	   		$list_three = 'selected="selected"';
	}

	
	if ($CONFIG['search_title'] == '1') {
		$option_output['search_title'] = 'checked="checked"';
	} else { 
		$option_output['search_title'] = '';
	}			
	if ($CONFIG['search_caption'] == '1') {
		$option_output['search_caption'] = 'checked="checked"';
	} else { 
		$option_output['search_caption'] = '';
	}				
	if ($CONFIG['search_keywords'] == '1') {
		$option_output['search_keywords'] = 'checked="checked"';
	} else { 
		$option_output['search_keywords'] = '';
	}				
	if ($CONFIG['search_filename'] == '1') {
		$option_output['search_filename'] = 'checked="checked"';
	} else { 
		$option_output['search_filename'] = '';
	}				
						
			
// +++++++++++++++++++
	// start form
	$superCage = Inspekt::makeSuperCage();
	echo <<< EOT
	<tr><td>
	<form name="cpgform" id="cpgform" action="{$_SERVER['REQUEST_URI']}" method="post">
EOT;
	
	starttable('100%',  sprintf($home_search_lang['configure_plugin_x'], $home_search_lang['display_name']), 2, 'cpg_zebra');	
	
	// reply with success to changes or no changes made
	if ($superCage->post->keyExists('submit')) {
    echo <<< EOT
	<tr>
		<td class="tableh2" colspan="2">
EOT;
    if ($config_changes_counter > 0) {
        msg_box('', $home_search_lang['update_success'], '', '', 'success');
    } else {
        msg_box('', $home_search_lang['no_changes'], '', '', 'validation');
    }
echo <<< EOT
		</td>
	</tr>
EOT;
}

	// complete form
echo <<< EOT
			<tr>
			<td><br><b>{$home_search_lang['page_head']}</b></td>
			</tr>
			<tr>
			<td></td>
			</tr>
			<tr>
			<td> 
			<hr> 
			{$home_search_lang['type_search']} <a href="plugins/home_search/docs/{$documentation_file}.htm#type_search" class="greybox" title="{{$home_search_lang['type_search']}}"><img src="images/help.gif" width="13" height="11" border="0" alt="" /></a>
			</td>
			<td>

			<br />
			<select name="search_type" id="search_type">
                 <option value="0" $list_one>{$home_search_lang['and']}</option>
                 <option value="1" $list_two>{$home_search_lang['or']}</option>
                 <option value="2" $list_three>{$home_search_lang['regex']}</option>
            </select>
			</td>
			</tr> 
			<tr>
            <td class="tableb" width="40%">
			<hr>
                {$home_search_lang['search_title']} <a href="plugins/home_search/docs/{$documentation_file}.htm#search_title" class="greybox" title="{$home_search_lang['search_title']}"><img src="images/help.gif" width="13" height="11" border="0" alt="" /></a>
            </td>
            <td>
                <input type="checkbox" name="search_title" id="search_title" class="checkbox" value="1" {$option_output['search_title']} />
                <label for="search_title" class="clickable_option">{$lang_common['yes']}</label>
            </td>
            </tr>
			<tr>
            <td class="tableb" width="40%">
			<hr>
                {$home_search_lang['search_caption']} <a href="plugins/home_search/docs/{$documentation_file}.htm#search_caption" class="greybox" title="{$home_search_lang['search_caption']}"><img src="images/help.gif" width="13" height="11" border="0" alt="" /></a>
            </td>
            <td>
                <input type="checkbox" name="search_caption" id="search_caption" class="checkbox" value="1" {$option_output['search_caption']} />
                <label for="search_caption" class="clickable_option">{$lang_common['yes']}</label>
            </td>
            </tr>
			<tr>
            <td class="tableb" width="40%">
			<hr>
                {$home_search_lang['search_keywords']} <a href="plugins/home_search/docs/{$documentation_file}.htm#search_keywords" class="greybox" title="{$home_search_lang['search_keywords']}"><img src="images/help.gif" width="13" height="11" border="0" alt="" /></a>
            </td>
            <td>
                <input type="checkbox" name="search_keywords" id="search_title" class="checkbox" value="1" {$option_output['search_keywords']} />
                <label for="search_keywords" class="clickable_option">{$lang_common['yes']}</label>
            </td>
            </tr>
			<tr>
            <td class="tableb" width="40%">
			<hr>
                {$home_search_lang['search_filename']} <a href="plugins/home_search/docs/{$documentation_file}.htm#search_filename" class="greybox" title="{$home_search_lang['search_filename']}"><img src="images/help.gif" width="13" height="11" border="0" alt="" /></a>
            </td>
            <td>
                <input type="checkbox" name="search_filename" id="search_title" class="checkbox" value="1" {$option_output['search_filename']} />
                <label for="search_filename" class="clickable_option">{$lang_common['yes']}</label>
            </td>
            </tr>
            <tr>
            <td class="tableb">
			<hr>
			{$home_search_lang['update_location']} <a href="plugins/home_search/docs/{$documentation_file}.htm#update_location" class="greybox" title="{$home_search_lang['search_loc']}"><img src="images/help.gif" width="13" height="11" border="0" alt="" /></a>
            </td>
            <td>
			<br />
            <input type="text" size="50" maxlength="250" class="textinput" style="width:90%" name="main_page_layout" id="main_page_layout"  value="{$CONFIG['main_page_layout']}" />
            </td>
			</tr>			
			<tr>			
	       <td class="tableb" align="right"><br /><br />
			<span>
			<input type="hidden" name="form_token" value="{$form_token}" />
    		<input type="hidden" name="timestamp" value="{$timestamp}" />
			<input type="submit" name="submit" value="{$home_search_lang['submit_change']}" /> 
		</span>
		</td>
		</tr>
		</td>		
EOT;
				  	/**** 
	$home_search_lang['search_title'] = 'Search by Titles';
$home_search_lang['search_caption'] = 'Search by Captions';
$home_search_lang['search_keywords'] = 'Search by Keywords';
$home_search_lang['search_filename'] = 'Search by File Names';				
	$search_type
	$search_title
	$search_caption
	$search_keywords
	$search_filename  ****/
	endtable();
	echo <<< EOT
	</form>
EOT;

	pagefooter();
	ob_end_flush();

?>