<?php
/**
 * Coppermine Photo Gallery
 * Coppermine version: 1.5.xx
 *
 * Home Search ver 1.0
 *
 * Plugin Written by Joe Carver - http://gallery.josephcarver.com/natural/ - http://i-imagine.net/artists/
 * 22 August 2010
*/

	if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

	// Add plugin_install action
	$thisplugin->add_action('plugin_install','home_search_install');

	// Add plugin_uninstall action
	$thisplugin->add_action('plugin_uninstall','home_search_uninstall');

	// Add plugin display action
	$thisplugin->add_filter('plugin_block','home_search_main');
	
	function home_search_main($block_search)
	{ 
	global $CONFIG, $matches;
	
    $icon_array['search'] = cpg_fetch_icon('search', 2);			
	 
	if($matches[1] != 'search') {
		return $block_search;
	}

	$search_type = <<< EOT
				<input type="hidden" name="type" value="AND" />
EOT;
	
	if ($CONFIG['search_type'] == 1)  {
	$search_type = <<< EOT
				<input type="hidden" name="type" value="OR" />
EOT;

	} elseif ($CONFIG['search_type'] == 2)  {
	$search_type = <<< EOT
				<input type="hidden" name="type" value="regex" />
EOT;
	}	

	$search_title = '';
	if ($CONFIG['search_title'] == 1)  {
	$search_title = <<< EOT
				<input type="hidden" name="title" id="title" />
EOT;
	}
	
	$search_caption = '';
	if ($CONFIG['search_caption'] == 1)  {
	$search_caption = <<< EOT
				<input type="hidden" name="caption" id="caption" />
EOT;
	}
	
	$search_keywords = '';
	if ($CONFIG['search_keywords'] == 1)  {
	$search_keywords = <<< EOT
				<input type="hidden"  name="keywords" id="keywords"  />
EOT;
	}	
	
	$search_filename = '';
	if ($CONFIG['search_filename'] == 1)  {
	$search_filename = <<< EOT
				<input type="hidden" name="filename" id="filename" />
EOT;
	}

$search_home = <<< EOT

<form method="get" action="thumbnails.php" name="searchcpg" id="cpgform3">
EOT;

echo  $search_home;
	// Create Display
	// 
starttable("100%");	
    include('plugins/home_search/init.inc.php');
echo <<< EOT
        <tr>
            <td class="tableb" align="center">
				<img src="images/spacer.gif" width="15" height="10" border="0" alt="" />
				{$home_search_lang['box_title']}
				<img src="images/spacer.gif" width="15" height="10" border="0" alt="" />		
				<input type="text" style="width: 60%" name="search" maxlength="100" value="" class="textinput" />
				<img src="images/spacer.gif" width="10" height="10" border="0" alt="" />
				<button type="submit" class="button" name="submit" id="submit" value="search">{$icon_array['search']}{$home_search_lang['button_title']}</button>
				<input type="hidden" name="album" value="search" />
{$search_type}
{$search_title}
{$search_caption}
{$search_keywords}
{$search_filename}
				<img src="images/spacer.gif" width="15" height="10" border="0" alt="" />				
            </td>
        </tr>	
	
	
EOT;


endtable();
	echo '</form>';
	}

	// Install the plugin
	function home_search_install() {
		global $CONFIG, $thisplugin;
		
		// add vars to db
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('search_type', '0')");
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('search_title', '1')");	
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('search_caption', '1')");
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('search_keywords', '1')");		
		cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('search_filename', '0')");		
		
		
		// Add the string "search" to "the content of the main page" top if it doesn't exist
		if (strpos($CONFIG['main_page_layout'], 'search') === FALSE) {
		$lead_trim = ltrim($CONFIG['main_page_layout'], '/');
		$contentOfTheMainpage = ('search/'.$lead_trim);
		cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value = '$contentOfTheMainpage' WHERE name = 'main_page_layout'"); 
					}		
			return true;
	}

	// Uninstall the plugin
	function home_search_uninstall() {
		global $CONFIG, $thisplugin;
	//remove the record from config
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'search_type'");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'search_title'");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'search_caption'");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'search_keywords'");
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'search_filename'");
			
	// Remove the string "search" from the config option "content of the main page"
		$contentOfTheMainpage = str_replace('/search', '', $CONFIG['main_page_layout']);
		$contentOfTheMainpage = str_replace('search/', '', $contentOfTheMainpage);
		$contentOfTheMainpage = str_replace('search', '', $contentOfTheMainpage);
		cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value = '$contentOfTheMainpage' WHERE name = 'main_page_layout'");

			return true;		
	}

?>